/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	code7.c - encode/decode 7bit-encoded block
 */
#include "transit.h"


decode7Block(rawbuff, sp)
char *sp, *rawbuff;
{
	register int data, data1, flag;
	char *dp, *chp;
	int i, crc, length;


	/* decode */
	for (flag = 0, dp = rawbuff; data = *sp++ & 0xff;) {
		if ((G0LOW <= data && data <= G0HIGH) ||
		    (G1LOW <= data && data <= G1HIGH)) {
			if (data <= G0HIGH)
				data -= OFFSET0;
			else
				data -= OFFSET1;
			if (flag != 0) {
				*(dp++) = data1 + ((data >> (7 - flag))
							& ((1 << flag) - 1));
			}
			flag = (flag + 1) & 7;
			data1 = data << flag;
		}
	}

	length = (rawbuff[DATALEN] & 0xff) + DATA;
	/* calculate crc */
	crc = 0;
	for (i = 0; i < length; i++) {
		crc = calc_crc((unsigned char)rawbuff[i], crc);
	}
	if (((rawbuff[length    ] & 0xff) != ((crc >> 8) & 0xff)) ||
	    ((rawbuff[length + 1] & 0xff) != ((crc     ) & 0xff))) {
		return (ERROR);
	}
	return (SUCCESS);
}


encode7Block(dst, src)
unsigned char *src, *dst;
{
	register unsigned int data, data1, length;
	int flag;


	data1 = 0;
	length = (src[DATALEN] & 0xff) + DATA + 2;
	for (flag = 6; length; --length) {
		data = *(src++) & 0xff;	/* byte data */

		*dst = data1 + (data >> (7 - flag));
		if (*dst & 0x40)
			*(dst++) += OFFSET1;
		else
			*(dst++) += OFFSET0;

		if (flag == 0) {
			*dst = data & 0x7f;
			if (*dst & 0x40)
				*(dst++) += OFFSET1;
			else
				*(dst++) += OFFSET0;
			data1 = 0;
			flag = 6;
		}
		else {
			data1 = (data << flag) & (0x80 - (1 << flag));
			flag--;
		}
	}
	if (flag != 6) {
		if (data1 & 0x40)
			*(dst++) = data1 + OFFSET1;
		else
			*(dst++) = data1 + OFFSET0;
	}

	/* terminate string */
	*dst = '\0';
}
