/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	transit.h - header file
 */

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

/* useful value */
#define TRUE	    1
#define FALSE	    0

/* return value */
#define SUCCESS     0			/* no error */
#define ERROR	    (-1)		/* error */
#define TIMEOUT     (-2)		/* no acknowlige, time out */

/* constant */
#define LINESIZE    256 		/* buffer size */
#define DATASIZE0   91			/* max raw data size / G0 set */
#define DATASIZE1   106			/* max raw data size / G1 set */

#define G0LOW	    0x30		/* character set area / G0 set */
#define G0HIGH	    0x6f
#define OFFSET0     0x30		/* convertion offset / G0 set */
#define G1LOW	    0xa0		/* character set area / G1 set */
#define G1HIGH	    0xdf
#define OFFSET1     0x60		/* convertion offset / G1 set */

#define MAXRETRY    10			/* retry 10 times */

/* time out value */
#define SHORTIME    10			/* 10 seconds */

/* raw data offset in buffer */
#define DATALEN     0			/* length of data */
#define BLOCKTYPE   1			/* block type */
#define BLOCKNUM    2			/* block number */
#define DATA	    3			/* raw data start offset */

/* data type */
#define CONTROL     0			/* initiate block */
#define DATABODY    1			/* data block */

/* abort type */
#define ABORT	    (-1)
#define QUIT	    (-2)

/* control character */
#define WINDOW	    'W' 		/* window width */
#define GRPH	    'G'			/* graphic set */
#define TERMINATE   'T' 		/* terminate transfer */

/* acknowlige type */
#define ACK	    'A' 		/* Acknowlige character */
#define NAK	    'N' 		/* Negate acknowlige */

/* character */
#define SENDCMD     's' 		/* argument/send files */
#define RECVCMD     'r' 		/*	    receive files */

#define VALIDCHAR   "#_-@."		/* valid character */

#define BINARYMODE  'b' 		/* send file with binary mode */
#define TEXTMODE    't' 		/* send file with text mode */
#define USEG1SET    'G' 		/* send file with use G1 */

#define UPDIR	    "UPDIR"
#define	DOWNDIR	    "DOWNDIR"

extern	abort(),
	quit();

extern	int	gmode;
extern	int	oopt;
extern	int	topt;
extern	int	gopt;


#define MAXSENDWIN  4			/* maximum window width on sending */
#define MAXRECVWIN  4			/* maximum window width on receiving */

#define FOPENWRB    "wb+"		/* fopen write binary mode */
#define FOPENWRT    "wt+"		/* fopen write text mode */
#define FOPENRDB    "rb"		/* fopen read binary mode */
#define FOPENRDT    "rt"		/* fopen read text mode */
#define PATHSPRTRS  ":/\\"		/* path name separater */

#define bcopy(s,d,i)	memcpy(d,s,i)

/* add by taka@exsysjuice.or.jp (on SUNOS4.1.1B) */
#ifdef DEBUG
#define	LOGFILE	"transit.log"
#define	putlog(c)	fputc((c), logptr);
extern FILE	*logptr;
#endif
