/*
	File transfer protocol "TransIt" Version 2.00
	BSD input/output routines.
	Copyright (C) 1992 by taka@exsys.juice.or.jp

	ΥϡҥƤ롢Transit V2.00
	ѤˡϤ˴ؤʬ򵭽ҤΤǤ

	бϡӣգΣϣӣ¤Ǥ

*/

/*
  	unixio.c,v 1.3 1994/03/31 04:56:16 tani Exp
*/

#if !defined(SYSV_TERMIO) && !defined(USE_TERMIO) && !defined(USE_SGTTY)
# define USE_SGTTY
#endif

#include "transit.h"

#ifdef FILIO_H
# include <sys/filio.h>
#else
# include <sys/ioctl.h>
#endif

#ifdef	USE_SGTTY
#include <sgtty.h>
#else
# ifdef SYSV_TERMIO
#  include <termio.h>
# else
#  include <termios.h>
# endif
#endif

#if defined(USE_TERMIO) && !defined(SYSV_TERMIO)
# define termio termios
# define IUCLC 0
#endif

#ifdef SYSV_TERMIO
# define	TCSANOW		TCSETA
# define	TCSADRAIN	TCSETAW
# define	TCSAFLUSH	TCSETAF
# define	tcgetattr(f, t)		ioctl(f, TCGETA, t)
# define	tcsetattr(f, a, t)	ioctl(f, a, t)
#endif

/* ttys setting backup structers */
#ifdef	USE_SGTTY
static struct sgttyb	tty_back;
#else
static struct termio	tty_back;
#endif

/* initailize port setting */
void rsdAttach()
{
#ifdef	USE_SGTTY
struct sgttyb	ttybtr;
	ioctl(0, TIOCEXCL, 0);
	ioctl(0, TIOCGETP, &tty_back);
	ioctl(0, TIOCGETP, &ttybtr);
	ttybtr.sg_flags &= ~( ECHO | ALLDELAY);
	ttybtr.sg_flags |= ( RAW);
	ioctl(0, TIOCSETN, &ttybtr);
#else
struct termio	ttybtr;
	tcgetattr(0, &tty_back);
	ttybtr = tty_back;
	ttybtr.c_cc[VMIN] = 1;
	ttybtr.c_cc[VTIME] = 0;
	ttybtr.c_iflag &= ~(INLCR|ICRNL|IUCLC|ISTRIP|IXON|BRKINT|IGNCR|IXOFF);
	ttybtr.c_oflag &= ~OPOST;
	ttybtr.c_lflag &= ~(ICANON|ISIG|ECHO|ECHOE|ECHOK|ECHONL|IEXTEN);
	ttybtr.c_cflag &= ~(CSIZE|PARENB);
	ttybtr.c_cflag |= CS8;

	tcsetattr(0, TCSAFLUSH, &ttybtr);
#endif
}

/* restore setting */
void rsdDetach()
{
	/* restore ttys setting */
#ifdef	USE_SGTTY
	ioctl(0, TIOCSETN, &tty_back);
	ioctl(0, TIOCNXCL, 0);
#else
	tcsetattr(0, TCSAFLUSH, &tty_back);
#endif
}

/* get read buffer count */
int rsdRetSize()
{
long	l;
	ioctl(0, FIONREAD, &l);
	return(l);
}

/* read data */
int readRsd(buf, cnt)
char	*buf;
int	cnt;
{
int	l;
	l = rsdRetSize();
	/* read */
	if ( l > 0) {
		l = read(0,buf, ((l > cnt) ? cnt : l));
	}
	/* return */
	return( (l > 0) ? l : 0);
}

/* write data */
void writeRsd(buf, cnt)
char	*buf;
int	cnt;
{
	write(1, buf, cnt);
}

/* get 1-char from console */
int cgetc()
{
	/* not support.. */
	return(-1);
}
